// Vererbung und Polymorphie

class FlugzeugTest {
	
	public static void main (String[] args) {
		
		Flugzeug flieger[] = new Flugzeug[5];
		flieger[0] = new A380 ();
		flieger[1] = new B787 ();
		flieger[2] = new F16_Falcon ();
		flieger[3] = new ModellFlugzeug ();
		flieger[4] = new Flugzeug ();
		
		for (int i = 0; i < flieger.length; i++) {
			flieger[i].abheben ();
			flieger[i].landen ();
		}
		
		// geht nicht, Flugzeug weiss nichts von schleudersitzBetaetigen ()
		//flieger[2].schleudersitzBetaetigen ();
		
		// so geht's aber
		F16_Falcon f16 = new F16_Falcon ();
		f16.schleudersitzBetaetigen ();
		
		// durch explizites Typcasting geht's auch, kommt erst spter :-)
		//((F16_Falcon) flieger[2]).schleudersitzBetaetigen ();		

		// Flugzeuge warten lassen
		Werkstatt pitStop = new Werkstatt ();
		for (Flugzeug einFlugObjekt : flieger) {
			pitStop.motorWarten (einFlugObjekt);
		}
	}
}


class Werkstatt {
	public void motorWarten (Flugzeug einFlieger) {
		System.out.println ("Flugzeug warten:");
		einFlieger.abheben ();
		einFlieger.landen ();
	}
}


class Flugzeug {
	public void abheben () {
		System.out.println ("Ein Flugzeug hebt ab.");
	}	

	public void landen () {
		System.out.println ("Ein Flugzeug landet.");
	}
}


class VerkehrsFlugzeug extends Flugzeug {
	private int anzahlPassagiere;
	
	public void setAnzahlPassagiere (int anzahl) {
		anzahlPassagiere = anzahl;
	}
	
	public int getAnzahlPassagiere () {
		return anzahlPassagiere;
	}
	
	public void abheben () {
		System.out.println ("Ein VerkehrsFlugzeug hebt ab.");
	}	
	
	public void landen () {
		System.out.println ("Ein VerkehrsFlugzeug landet.");
	}
}


class KampfFlugzeug extends Flugzeug {
	public void schleudersitzBetaetigen () {
		System.out.println ("Ein KampfFlugzeug ist jetzt ohne Sitz und ohne Pilot.");
	}
}


class ModellFlugzeug extends Flugzeug {
	public void abheben () {
		System.out.println ("Ein ModellFlugzeug hebt ab.");
	}	
	
	public void landen () {
		System.out.println ("Ein ModellFlugzeug landet.");
	}
}


class Airbus extends VerkehrsFlugzeug {
	public void abheben () {
		System.out.println ("Ein Airbus hebt ab.");
	}	
	
	public void landen () {
		System.out.println ("Ein Airbus landet.");
	}
}


class Boeing extends VerkehrsFlugzeug {
	public void abheben () {
		System.out.println ("Eine Boeing hebt ab.");
	}	
	
	public void landen () {
		System.out.println ("Eine Boeing landet.");
	}
}


final class A380 extends Airbus {
	public void abheben () {
		System.out.println ("Eine A380 hebt ab.");
	}
	
	public void landen () {
		System.out.println ("Ein A380 landet.");
	}
}


final class B787 extends Boeing {
	public void abheben () {
		System.out.println ("Eine B787 hebt ab.");
	}
	
	public void landen () {
		System.out.println ("Ein B787 landet.");
	}
}


final class F16_Falcon extends KampfFlugzeug {
	public void abheben () {
		System.out.println ("Eine F16 hebt ab.");
	}
	
	public void landen () {
		System.out.println ("Eine F16 landet.");
	}
}